<!--<h1>Users</h1>-->

<!--Structural Directives-->
<!--ngIf = creates conditionals in our template()-->
<!--ngFor = used to loop through an array-->
<!--* Adding logic into our template-->
<!--Every Structural Directive Needs to have the asterisk (*)-->

<!--<h3>{{users[0].firstName}}</h3>-->
<!--<h3>{{users[1].firstName}}</h3>-->

<button (click)="showUserForm = !showUserForm" class="btn btn-dark mb-3">Add User</button>
<div class="card card-body mb-3" *ngIf="showUserForm">
<h2>Add User</h2>
  <form #userForm = "ngForm" (ngSubmit)="onSubmit(userForm)">
    <div class="form-group">
      <label>First Name</label>
      <input
        type = "text"
        [(ngModel)]="user.firstName"
        class="form-control is-invalid"
        name="firstName"
        #userFirstName="ngModel"
        required
        minlength="2"
      >

      <div [hidden]="!userFirstName.errors?.required" class="invalid-feedback">
        First Name Required
      </div>
    </div>

    <div class="form-group">
      <label>Last Name</label>
      <input type = text [(ngModel)]="user.lastName" class="form-control is-invalid" name="lastName">
      <div class="invalid-feedback">
        Last Name Required
      </div>

    </div>

    <div class="form-group">
      <label>Age</label>
      <input type = text [(ngModel)]="user.age" class="form-control is-invalid" name="age">
      <div class="invalid-feedback">
        Age Required
      </div>
    </div>

    <div class="form-group">
      <label>Email</label>
      <input
        type = 'email' [(ngModel)]="user.email"
        [ngClass]="{'is-invalid': userEmail.errors && userEmail.touched}"
        class="form-control"
        name="email"
        #userEmail = 'ngModel'
        required
        pattern="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?"
      >
      <div [hidden]="!userEmail.errors?.required" class="invalid-feedback">
        Email Required
      </div>
      <div [hidden]="!userEmail.errors?.pattern" class="invalid-feedback">
        Email is not Valid
      </div>
    </div>



    <button [disabled]="!userForm.form.valid" class="btn btn-block mb-3">Add New User</button>
  </form>
</div>

<!--<button (click) = "addUser({firstName: 'Jane', lastName: 'Smith', age: 22, email: 'jane@gmail.com'})" [disabled]="enableAddUser" class="btn btn-light btn-block mb-3" [ngClass]="currentClass">Add New User</button>-->

<div>
<ul class="list-unstyled" *ngIf="users.length > 0">
<!--  Class Binding - add or use certain classes depending on certain properties, values, or aspect of a component-->
  <li class="card card-body mb-2" *ngFor="let user of users" [class.bg-primary]="user.isActive">
    <div class="row">
      <div class="col-sm-4">
<!--        BIND OUR IMAGE PROPERTY-->
        <img *ngIf="!user.hide && user.age && user.email" class="img-fluid" [src]="user.image" alt="">
<!--OTHER WAY BINDING OUR IMAGE-->
<!--        <img class="img-fluid" src="{{ user.image }}" alt="">-->
<!--        <img class="img-fluid" bind-src=" user.image " alt="">-->




      </div>
      <div class="col-sm-8">

<!--&lt;!&ndash;        [ngStyle]&ndash;&gt;  Below in small tag - if user has age and address fire off click event-->
        <h2 [ngStyle]="currentStyle">{{ user.firstName }} {{ user.lastName }} <button (click)="toggleHide(user) " class="btn btn-dark btn-sm"><i [ngClass]="user.hide ? 'fa fa-minus' : 'fa fa-minus'"></i></button></h2>
        <ul *ngIf="!user.hide && user.age && user.email">
          <li>Age: {{ user.age }}</li>
          <li>Email: {{ user.email }} </li>

<!--          Angular Pipes - a way to format our data in our template-->
          <li class="list-group-item">Balance: {{ user.balance | currency}}</li>
<!--          <li class="list-group-item">Balance: {{ user.balance | currency: "USD":""}}</li>-->
<!--Example for date pipe-->
          <li class="list-group-item">
<!--            {{ user.memberSince | date }}-->
            {{ user.memberSince | date: "dd/MM/yyyy" }}
            {{ user.memberSince | date: "yyyy" }}
            {{ user.memberSince | date: "fullDate" }}
            <!--            mm = minutes / MM = month-->
          </li>

<!--          Example for number pipe-->
          <li class="list-group-item">
            {{ 5 | number:"2.4" }}
          </li>
<!--          Example for percent pipe-->
          <li class="list-group-item">
<!--            {{ 1 | percent}}-->
            <pre ngNonBindable>{{ .5 | percent}} </pre>
            {{ .5 | percent}}
          </li>

<!--          ngNonBindable - makes an element(s) disabled to binding data -->
          <li class="list-group-item" ngNonBindable>
            {{ 1 | percent}}
            {{ .5 | percent}}

          </li>
        </ul>
      </div>
    </div>
  </li>
</ul>
<h3 *ngIf="users.length === 0">No Users Found</h3>
<!--<h3 *ngIf="!users">Loading Users...</h3>-->
</div>

<!--<div class="form-group">-->
<!--  <label>Email</label>-->
<!--  <input type = text [(ngModel)]="user.email" class="form-control is-invalid" name="email">-->
<!--  <div class="invalid-feedback">-->
<!--    Email Required-->
<!--  </div>-->


<!--<ul>-->
<!--&lt;!&ndash;<ul *ngIf="users.length > 4">&ndash;&gt;-->
<!--&lt;!&ndash;  <li *ngFor="let user of users">&ndash;&gt;-->
<!--&lt;!&ndash;    <h3>{{user.firstName}} {{user.lastName}}</h3>&ndash;&gt;-->
<!--&lt;!&ndash;    <ul *ngIf="!displayInfo"> //!displayInfo would not show info&ndash;&gt;-->
<!--&lt;!&ndash;      <li>Age: {{user.age}}</li>&ndash;&gt;-->
<!--&lt;!&ndash;      <li>Address: {{user.address.street}}, {{user.address.city}}, {{user.address.state}}</li>&ndash;&gt;-->
<!--&lt;!&ndash;    </ul>&ndash;&gt;-->
<!--&lt;!&ndash;  </li>&ndash;&gt;-->
<!--&lt;!&ndash;  <li *ngFor="let user of users">&ndash;&gt;-->
<!--&lt;!&ndash;    Age: {{user.age}}&ndash;&gt;-->
<!--&lt;!&ndash;  </li>&ndash;&gt;-->
<!--</ul>-->

<!--&lt;!&ndash;//Another example of ngIf&ndash;&gt;-->

<!--<h3 *ngIf="users.length === 0">No users found</h3>-->

